/*
* Alabastra Project - C++ Editor writed with QT Library V.4 
* Copyright (C) Igor Maculan - n3wtron@gmail.com
			Marco Buoncristiano - marco.buoncristiano@gmail.com
 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "AlSyntax.h"
#include "AlSyntaxCpp.h"
#include "AlSyntaxHtml.h"
#include "AlSyntaxPhp.h"
#include <QDebug>

AlSyntax::AlSyntax(QObject *parent) : QSyntaxHighlighter(parent)
{};

AlSyntax::AlSyntax(QTextEdit *parent): QSyntaxHighlighter(parent)
{};

AlSyntax::AlSyntax(QTextDocument *parent): QSyntaxHighlighter(parent)
{};

AlSyntax* AlSyntax::getSyntax(QString type,QTextDocument *parent){
	if (type=="cpp" || type=="h" || type=="c" || type=="cc")
		return new AlSyntaxCpp(parent);
	if (type=="html" || type=="htm" )
		return new AlSyntaxHtml(parent);
	if (type=="php" )
		return new AlSyntaxPhp(parent);
	return new AlSyntaxCpp(parent);
};
