/*
* Alabastra Project - C++ Editor writed with QT Library V.4 
* Copyright (C) Igor Maculan - n3wtron@gmail.com
Marco Buoncristiano - marco.buoncristiano@gmail.com

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "AlMethodHltCpp.h"
#include <QTextCursor>
#include <QTextCharFormat>
#include <QRegExp>
#include <QDebug>


AlMethodHltCpp::AlMethodHltCpp(AlDocument *doc) : AlMethodHighLight(doc){};

void AlMethodHltCpp::refreshMethod(){
	QString mName;
	qDebug()<<doc->getUndoStack()->count();
	disconnect (doc,SIGNAL(modificationChanged(bool)),doc,SLOT(documentModified(bool)));
	QTextCursor cM((QTextDocument*)doc); 
	cM.movePosition(QTextCursor::Start);
	QRegExp extMethod=QRegExp("::([A-Z]|[0-9]|[_])*([(]|[ ]*[(])([A-Z]|[0-9]|[ ]|[,]|[*]|[_]|[&])*[)](?!(.*[;]))",Qt::CaseInsensitive,QRegExp::RegExp2);
	cM=doc->find(extMethod,cM);
	QString line;
	AlMethod *method;
	//memorizzo lo stato di modifica
	bool mod=doc->isModified();
	while ( !cM.isNull() ){
		method=new	AlMethod();			
		line=cM.selectedText();
		mName=line.mid(2,line.length()-2);
		method->setName(mName);
		QTextCharFormat chrMethodFormat;
		chrMethodFormat.setAnchor(true);
		chrMethodFormat.setAnchorName(mName);
		cM.setCharFormat(chrMethodFormat);
		alMethodList<<method;
		cM.movePosition(QTextCursor::NextBlock);
		cM=doc->find(extMethod,cM);
	}
	//Ripristino lo stato di modifica
	doc->setModified(mod);
	connect (doc,SIGNAL(modificationChanged(bool)),doc,SLOT(documentModified(bool)));
	qDebug()<<doc->getUndoStack()->count();
};
