/*
* Alabastra Project - C++ Editor writed with QT Library V.4 
* Copyright (C) Igor Maculan - n3wtron@gmail.com
Marco Buoncristiano - marco.buoncristiano@gmail.com

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "AlMethodHltH.h"
#include <QTextCursor>
#include <QTextCharFormat>
#include <QRegExp>

AlMethodHltH::AlMethodHltH(AlDocument *doc) : AlMethodHighLight(doc){};

void AlMethodHltH::refreshMethod(){
	QString rName;
	disconnect (doc,SIGNAL(modificationChanged(bool)),doc,SLOT(documentModified(bool)));
	QTextCursor cM((QTextDocument*)doc);
	cM.movePosition(QTextCursor::Start);
	QRegExp extMethod=QRegExp("(([A-Z]|[0-9]|[_]|[*]|[>]|[<])*[ ]*([A-Z]|[0-9]|[_])*[(]([A-Z]|[0-9]|[ ]|[,]|[*]|[_]|[&])*[)][;])|(class[ ]*([A-Z]|[0-9]|[_])*)",
	Qt::CaseInsensitive,QRegExp::RegExp2);
	cM=doc->find(extMethod,cM);
	alMethodList.clear();
	AlMethod* method;
	//memorizzo lo stato di modifica
	bool mod=doc->isModified();
	QString line;
	QString className;
	int spPos,parPos;
	while ( !cM.isNull() ){
		line=cM.selectedText();
		if (line.contains("class")){
		className=line.mid(5).simplified();
		}
		else{
			line=line.left(line.size()-1);
			method=new AlMethod();
			spPos=line.indexOf(" ");
			parPos=line.indexOf("(");
			if (spPos>0 && spPos<parPos){
				//non  un costruttore
				rName=line.left(spPos);
				method->setReturnName(rName);
				line=line.right(line.size()-(spPos+1));
			}
			method->setName(line);
			if (!className.isEmpty())
			method->setClassName(className);
			QTextCharFormat chrMethodFormat;
			chrMethodFormat.setAnchor(true);
			chrMethodFormat.setAnchorName(method->getName());
			cM.setCharFormat(chrMethodFormat);
			alMethodList<<method;
		}
		cM.movePosition(QTextCursor::NextBlock);
		cM=doc->find(extMethod,cM);
	}
	//Ripristino lo stato di modifica
	doc->setModified(mod);
	connect (doc,SIGNAL(modificationChanged(bool)),doc,SLOT(documentModified(bool)));
};
